<?php

include_once (MYSQL);
include_once (dirname(__FILE__)."/localization.php");

class users {

    function users () {
		$this->DB = new DB;
		$this->DB->connect();
		$this->LOCALIZE = new localization;
    }
	
	/*
	* Profile
	*/
	function viewingProfile($id, $looking_id, $looked_name, $lang) {
		$lang = $this->LOCALIZE->checkLanguage($lang);
		$this->DB->query("INSERT INTO users_viewing (user_id, looked_id, looked_name, looked_date) 
						  VALUES('$id', '$looking_id', '$looked_name', UNIX_TIMESTAMP());");
		$getdata = $this->DB->query("SELECT * FROM users WHERE id =  '$id' LIMIT 1");
		$section = $this->DB->fetch_array($getdata);
		$result = unserialize($section['data']);
		$result['name'] = $section['name'];
		$gender = $result['gender'];
		if ($section['avatar'] != "") {
			$result['avatar'] = $section['avatar'];
		} else {
			switch ($gender) {
				case "m":
					$result['avatar'] = "upload/m_avatar.jpg";
					break;
				case "f":
					$result['avatar'] = "upload/f_avatar.jpg";
					break;
			}
		}
		$result['country'] = $result['country'] != "" ? $this->LOCALIZE->getContryName($result['country'], $lang) : "";
		$result['join_date'] = date("Y.m.d H:i:s", $section['join_date']);
		$result['last_login'] = $section['last_login'] == 0 ? "..." : date("Y.m.d H:i:s", $section['last_login']);
		$result['gender'] = $result['gender'] == "m" ? $this->LOCALIZE->getPhrase('male', $lang) : $this->LOCALIZE->getPhrase('female', $lang);
		$result['email'] = $section['publish_email'] == 1 ? $section['email'] : "...";
		$result['languages'] = $this->LOCALIZE->getNames($result['languages'], $lang);
		return $result;
	}
	
	function getProfile($id) {
		$getdata = $this->DB->query("SELECT * FROM users WHERE id =  '$id' LIMIT 1");
		$section = $this->DB->fetch_array($getdata);
		$result = unserialize($section['data']);
		$result['name'] = $section['name'];
		$gender = $result['gender'];
		$result['active'] = $section['active'];
		if ($section['avatar'] != "") {
			$result['avatar'] = $section['avatar'];
		} else {
			switch ($gender) {
				case "m":
					$result['avatar'] = "upload/m_avatar.jpg";
					break;
				case "f":
					$result['avatar'] = "upload/f_avatar.jpg";
					break;
			}
		}
		$result['join_date'] = date("Y.m.d H:i:s", $section['join_date']);
		$result['last_login'] = $section['last_login'] == 0 ? "..." : date("Y.m.d H:i:s", $section['last_login']);
		$result['email'] =      $section['email'];
		$result['publish_email'] =   $section['publish_email'];
		$result['languages'] = explode(",", $result['languages']);
		return $result;
	}
	
	function setProfile($id, $utype, $name, $obj, $email, $publish_email = 0, $active, $lang) {
		
		$lang = $this->LOCALIZE->checkLanguage($lang);
		
		$name = addslashes($name);
		$email = addslashes($email);
		$data = addslashes(serialize($obj));
		
		$getdata = $this->DB->query("SELECT id FROM users WHERE name = '$name' AND id <> '$id' LIMIT 1");
		$rows = $this->DB->get_num_rows($getdata);
		if ($rows > 0) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('r_name_exists', $lang),
						 'title' => $this->LOCALIZE->getPhrase('error', $lang));
		}
		
		$getdata = $this->DB->query("SELECT id FROM users WHERE email = '$email' AND id <> '$id' LIMIT 1");
		$rows = $this->DB->get_num_rows($getdata);
		if ($rows > 0) {
			return array('valid' => false, 
						 'error' => $this->LOCALIZE->getPhrase('r_email_exists', $lang),
						 'title' => $this->LOCALIZE->getPhrase('error', $lang));
		}
		
		$this->DB->query("UPDATE users 
						  SET utype = '$utype', name = '$name', active = '$active', 
						  email = '$email', publish_email = '$publish_email', data = '$data'
						  WHERE id = '$id' LIMIT 1;");
		
		return array('valid' => true);
	}
	
	function getOwnerData($id) {
		$getdata = $this->DB->query("SELECT * FROM users WHERE id =  '$id' LIMIT 1");
		$section = $this->DB->fetch_array($getdata);
		$result['id'] = $section['id'];
		$result['utype'] = $section['utype'];
		$result['name'] = $section['name'];
		return $result;
	}
	
	function changePassword($id, $old_pass, $new_pass, $ver, $lang) {
		
		$lang = $this->LOCALIZE->checkLanguage($lang);
		
		if ($ver) {
			$getdata = $this->DB->query("SELECT password FROM users WHERE id = '$id' LIMIT 1; ");
			$section = $this->DB->fetch_array($getdata);
			$password = $section['password'];
			if (md5($old_pass) != $password) {
				$result = array('valid' => false, 
								'error' => $this->LOCALIZE->getPhrase('profile_error_old_password', $lang),
								'title' => $this->LOCALIZE->getPhrase('alert', $lang));
				return $result;
			}
		}
		
		$new_pass = md5($new_pass);
		
		$this->DB->query("UPDATE users SET password = '$new_pass' WHERE id = '$id' LIMIT 1;");
		
        $result = array('valid' => true);
		return $result;
		
	}
	
	/*
	* Frinds List
	*/
	function addToFriends($user_id, $friend_id) {
		
		if ($user_id == $friend_id) return false;
		
		$getdata = $this->DB->query("SELECT COUNT(*) as count FROM users_friends 
									 WHERE user_id = '$user_id' AND  friend_id = '$friend_id' LIMIT 1; ");
		$section = $this->DB->fetch_array($getdata);
		
		$count = $section['count'];	
		
		if ($count == 0) {
			$this->DB->query("INSERT INTO users_friends (user_id, friend_id) VALUES('$user_id', '$friend_id');");
			return $this->getFriends($user_id, true);
		} else {
			return false;
		}
		
	}
	
	function removeFromFriends($user_id, $friend_id) {
		
		if ($user_id == $friend_id) return false;
		
		$this->DB->query("DELETE FROM users_friends WHERE user_id = '$user_id' AND  friend_id = '$friend_id'  LIMIT 1;");
		
		return $this->getFriends($user_id, true);
		
	}
	
	function getFriends($user_id, $only_id=false) {
		
		$friends = array();
		$getdata = $this->DB->query("SELECT users.id,
									        users.name,
									        users.utype,
									        users.avatar,
									        users.`status`
									 FROM users_friends
									 Inner Join users ON users_friends.friend_id = users.id
									 WHERE users_friends.user_id =  '$user_id'");
		
		while($section = $this->DB->fetch_array($getdata)) {
			if (!$only_id) {
				$friends[] = array('id' => $section['id'], 'name' => $section['name'], 'status' => $section['status']);			   
			} else {
				$friends[] = $section['id'];
			}
		}
		
		return $friends;
		
	}
	
	/*
	*
	* Bloks List
	*
	*/
	
	function addToBlocks($user_id, $block_id) {
		
		if ($user_id == $block_id) return false;
		
		$getdata = $this->DB->query("SELECT COUNT(*) as count FROM users_blocks 
									 WHERE user_id = '$user_id' AND  block_id = '$block_id' LIMIT 1; ");
		$section = $this->DB->fetch_array($getdata);
		
		$count = $section['count'];	
		
		if ($count == 0) {
			$this->DB->query("INSERT INTO users_blocks (user_id, block_id) VALUES('$user_id', '$block_id');");
			return $this->getBlocks($user_id, true);
		} else {
			return false;
		}
		
	}
	
	function removeFromBlocks($user_id, $block_id) {
		
		if ($user_id == $block_id) return false;
		
		$this->DB->query("DELETE FROM users_blocks WHERE user_id = '$user_id' AND  block_id = '$block_id'  LIMIT 1;");
		
		return $this->getBlocks($user_id, true);
		
	}
	
	function getBlocks($user_id, $only_id=false) {
		
		$blocks = array();
		$getdata = $this->DB->query("SELECT users.id,
									        users.name,
									        users.utype,
									        users.avatar,
									        users.`status`
									 FROM users_blocks
									 Inner Join users ON users_blocks.block_id = users.id
									 WHERE users_blocks.user_id =  '$user_id'");
		
		while($section = $this->DB->fetch_array($getdata)) {
			if (!$only_id) {
				$blocks[] = array('id' => $section['id'], 'name' => $section['name'], 'status' => $section['status']);		   
			} else {
				$blocks[] = $section['id'];
			}
			
		}
		
		return $blocks;
		
	}
	
	function getUsers($page, $count, $status) {
		
		switch ($status) {
			case 1:
				$add = "WHERE active = 1 AND users.last_login <> 0";
				break;
			case 2:
				$add = "WHERE active = 0";
				break;
			case 3:
				$add = "WHERE users.last_login = 0";
				break;
			case 4:
				$add = "WHERE users.utype = 'moderator'";
				break;
			case 5:
				$add = "WHERE users.utype = 'admin'";
				break;
			case 0:
			default:
				$add = "";
				break;
		}
		
		$start = ($page - 1) * $count;
		$getdata = $this->DB->query("SELECT users.id, users.utype, users.name, users.email, users.avatar,
                                     FROM_UNIXTIME(users.join_date, '%Y.%m.%d %H:%i:%s') AS join_date,
                                     FROM_UNIXTIME(users.last_login, '%Y.%m.%d %H:%i:%s') AS last_login,
                                     users.active 
									 FROM users $add ORDER BY users.name ASC LIMIT $start, $count;");
									 
		while($section = $this->DB->fetch_array($getdata)) {
			$users[] = array('id' => $section['id'],
			                 'name' => trim($section['name']),
							 'utype' => trim($section['utype']),
			                 'email' => $section['email'],
							 'avatar' => $section['avatar'],
							 'join_date' => $section['join_date'],
							 'last_login' => $section['last_login'] == "1970.01.01 10:00:00" ? "" : $section['last_login'],
							 'active' => $section['active'] == 1 ? true : false);
		}
		
		$getdata = $this->DB->query("SELECT COUNT(*) AS count FROM users $add;");
		$section = $this->DB->fetch_array($getdata);
		$total = $section['count'];
		
		return array('data' => $users, 'total' => ceil($total/$count), 'current' => $page, 'count' => $total);
		
	}
	
	function removeUsers($users) {
		for ($i=0; $i<count($users); $i++) {
			$user_id = $users[$i];
			$this->DB->query("DELETE FROM users WHERE id = '$user_id' LIMIT 1;");
		}
		return true;
	}
	
}

?>